<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Index extends Controller_UserEnvironment {

    public function action_index()
    {
        $twig = Twig::factory('teacher/index');

        $disciplines = Model_Disciplines::ofTeacher($this->user['TeacherID']);
        $subjID = $discID = $gradeNum = $i = $j = $k = 0; // Combo!!!
        $disciplinesHandled = array();
        $groupsInDiscipline = array();
        
        foreach ($disciplines as $row) {
            if($subjID != $row['SubjectID'] || $gradeNum != $row['GradeID'])
            {
                $i++; $j = $k = 0;
                $groupsInDiscipline = array();
                $subjID = $row['SubjectID'];
                $gradeNum = $row['GradeID'];
                $disciplinesHandled[$i]['Title'] = $row['SubjectName'];
                $disciplinesHandled[$i]['GradeNum'] = $row['GradeNum'];
                $disciplinesHandled[$i]['Degree'] = Model_Grades::getDegreeTitle($row['Degree']);
                               
            }
            
            if($discID != $row['ID'])
            {
                $j++; $k = 0;
                $groupsInDiscipline = array();
                $disciplinesHandled[$i]['Disciplines'][$j]['IsAuthor'] = $row['IsAuthor'];
                $disciplinesHandled[$i]['Disciplines'][$j]['IsLocked'] = $row['IsLocked'];
                $disciplinesHandled[$i]['Disciplines'][$j]['IsMapCreated'] = $row['IsMapCreated'];
                $disciplinesHandled[$i]['Disciplines'][$j]['ID'] = $discID = $row['ID'];
                $disciplinesHandled[$i]['Disciplines'][$j]['ControlType'] = $this->getControlType($row['ExamType']);
                $disciplinesHandled[$i]['Disciplines'][$j]['Teachers'] = $this->getTeachersForDiscipline($discID);
            }
            if($row['GroupNum'] != 0)
                $groupsInDiscipline[++$k] = $row['GroupNum'].' гр.';
            $disciplinesHandled[$i]['Disciplines'][$j]['Groups'] = implode(', ', $groupsInDiscipline);
        } //!for_each
        $twig->Subjects = $disciplinesHandled;
        $twig->SemesterList = Model_Semesters::toArray();
        $twig->Semester = $this->SemesterInfo;
        $twig->User = $this->user;
        $this->response->body($twig);
    }
    
    public function action_settings() {
        $twig = Twig::factory('settings');
        $twig->User = $this->user;
        $this->response->body($twig);
    }
    
    protected function getControlType($type)
    {
        if($type == 'exam')
        {
            return 'Экзамен';
        }
        elseif($type == 'credit')
        {
            return 'Зачет';
        }
    }
    
    protected function getTeachersForDiscipline($id) {
        $teachers = Model_Teachers::ofDiscipline($id);
        $teachersHandled = array(); $i = 0;
        foreach ($teachers as $teacher)
        {
            $i++;
            $teachersHandled[$i] = $teacher['LastName'].' '.UTF8::substr($teacher['FirstName'], 0, 1).'. ';
            if(!empty($teacher['SecondName']))
            {
                $teachersHandled[$i] .= UTF8::substr($teacher['SecondName'], 0, 1).'.';
            }
        }
        return $teachersHandled;
    }
}