<?php defined('SYSPATH') or die('No direct script access.');

class Model_Teachers extends Model
{
    public static function getFaculties() {
        $sql = "CALL `GetFaculties`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function getJobPositions() {
        $sql = "CALL `GetJobPositions`(); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getTeachersByFaculty($facultyID) {
        $sql = "CALL `GetTeachersByFaculty`('$facultyID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function byFaculty($facultyID) {
        $list = array();

        if ($facultyID > 0) {
            $teachers = self::getTeachersByFaculty($facultyID);

            foreach ($teachers as $row) {
                $row['DepartmentID'] = $row['DepID'];
                $row['DepartmentName'] = $row['DepName'];
                $list[] = $row;
            }
        }

        return $list;
    }

    public static function getTeachersByDepartment($departmentID) {
        $sql = "CALL `GetTeachersByDepartment`('$departmentID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function byDepartment($departmentID) {
        $teachers = self::getTeachersByDepartment($departmentID);
        $list = array();

        foreach ($teachers as $row) {
            $row['DepartmentName'] = $row['DepName'];
            $list[] = $row;
        }

        return $list;
    }

    /**
     * @param $id int discipline id
     * @return Database_Result select from <tt>view_disciplines_teachers</tt> table
     */
    public static function ofDiscipline($id) {
        $sql = "CALL `GetTeachersForDiscipline`('$id'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function forDiscipline($disciplineID, $asConcat = false, $asInitials = false) {
        $teachers = self::ofDiscipline($disciplineID);
        $list = array();

        foreach ($teachers as $row) {
            if ($asInitials) {
                $row['FirstName'] = UTF8::substr($row['FirstName'], 0, 1) . '. ';
                if (!empty($row['SecondName']))
                    $row['SecondName'] = UTF8::substr($row['SecondName'], 0, 1) . '. ';
            }

            if ($asConcat)
                $list[] = $row['LastName'] . $row['FirstName'] . $row['SecondName'];
            else
                $list[] = $row;
        }

        return $list;
    }

    public static function searchTeachers($FacultyID, $DepartmentID, $Last, $First, $Second) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeachers`('$FacultyID', '$DepartmentID', $Last, $First, $Second); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public static function searchTeacherNew($FacultyID, $DepartmentID, $Last, $First, $Second, $DisciplineID) {
        $db = Database::instance();
        $Last = $db->escape($Last);
        $Second = $db->escape($Second);
        $First = $db->escape($First);
        $sql = "CALL `SearchTeacherNew`('$FacultyID', '$DepartmentID', $Last, $First, $Second, '$DisciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }
}